
Core - Bug # 39967

Status: Resolved Priority: Must have
Author: Helmut Hummel Category: Default
Created: 2012-08-19 Assigned To:
Updated: 2014-09-12 Due date:
TYPO3 Version: 6.2
PHP Version:
Complexity: easy
Is Regression: No
Sprint Focus:
Subject: mod.SHARED.colPos_list is not taken into account any more
Description

Since the merge of the https://review.typo3.org/13510
mod.SHARED.colPos_list is not taken into account any more as a hardcoded backend layout is used with all columns.

Related issues:
related to TYPO3 CMS Usability Team - Suggestion # 38013: Separate the differ... Closed 2012-06-13
related to Core - Task # 39603: Move default columns to a backend_layout conf... Resolved 2012-08-08
related to Core - Bug # 43511: Page TSconfig option mod.SHARED.colPos_list do... Resolved 2012-12-02
related to TSconfig - Task # 47071: Mark mod.SHARED.colPos_list as removed Resolved 2013-04-09
related to Core - Bug # 53898: Unused code in PageLayoutView (~100 lines) Resolved 2013-11-23

Associated revisions
Revision 241f4d0e - 2014-09-07 17:02 - Jigal van Hemert

[BUGFIX] colPos_list sets access to edit areas

The property mod.SHARED.colPos_list used to determine which columns
were visible in the Page module. With backend layouts it will only
determine which edit areas in the backend layout are accessible for
editing.

Resolves: #39967
Releases: 6.3, 6.2
Change-Id: Iba65ce84adf025802d1b0ebda00dff4d6299a06a
Reviewed-on: http://review.typo3.org/31783
Reviewed-by: Wouter Wolters <typo3@wouterwolters.nl>
Reviewed-by: Marcin Sągol <marcin@soee.pl>
Reviewed-by: Jo Hasenau <info@cybercraft.de>
Reviewed-by: Jigal van Hemert <jigal.van.hemert@typo3.org>
Tested-by: Jigal van Hemert <jigal.van.hemert@typo3.org>

Revision cb3dc5e4 - 2014-09-07 17:08 - Jigal van Hemert

[BUGFIX] colPos_list sets access to edit areas

The property mod.SHARED.colPos_list used to determine which columns
were visible in the Page module. With backend layouts it will only
determine which edit areas in the backend layout are accessible for
editing.

Resolves: #39967
Releases: 6.3, 6.2
Change-Id: Iba65ce84adf025802d1b0ebda00dff4d6299a06a
Reviewed-on: http://review.typo3.org/32615
Reviewed-by: Jigal van Hemert <jigal.van.hemert@typo3.org>
Tested-by: Jigal van Hemert <jigal.van.hemert@typo3.org>

Revision 20de0fc4 - 2014-09-10 11:56 - Helmut Hummel

[BUGFIX] Followup to mod.SHARED.colPos_list fix

The internal property activeColPosList is intermediately
set to an array and not converted to a comma separated list
any more, which breaks related code.

Resolves: #39967
Releases: 6.2, 6.3
Change-Id: I6f2e4710174ad5277f9de47c2d7b2cbb7a5ebb80
Reviewed-on: http://review.typo3.org/32697
Reviewed-by: Helmut Hummel <helmut.hummel@typo3.org>
Tested-by: Helmut Hummel <helmut.hummel@typo3.org>
Reviewed-by: Nicole Cordes <typo3@cordes.co>
Reviewed-by: Jo Hasenau <info@cybercraft.de>
Reviewed-by: Jigal van Hemert <jigal.van.hemert@typo3.org>
Tested-by: Jigal van Hemert <jigal.van.hemert@typo3.org>

Revision 6a389870 - 2014-09-12 17:54 - Jigal van Hemert

[BUGFIX] Followup 2 to mod.SHARED.colPos_list fix

Deal with empty mod.SHARED and fill activeColPosList with colPosList
in case the TSconfig setting is empty.

Resolves: #39967
Releases: 6.2, 6.3
Change-Id: I5e2e4420de8f1d603e13a03758f97803e545d9a3
Reviewed-on: http://review.typo3.org/32712
Reviewed-by: Anja Leichsenring <aleichsenring@ab-softlab.de>
Tested-by: Anja Leichsenring <aleichsenring@ab-softlab.de>
Reviewed-by: Helmut Hummel <helmut.hummel@typo3.org>
Tested-by: Helmut Hummel <helmut.hummel@typo3.org>

Revision b60a40cb - 2014-09-12 17:57 - Helmut Hummel

[BUGFIX] Followup to mod.SHARED.colPos_list fix

The internal property activeColPosList is intermediately
set to an array and not converted to a comma separated list
any more, which breaks related code.

Resolves: #39967
Releases: 6.2, 6.3
Change-Id: I6f2e4710174ad5277f9de47c2d7b2cbb7a5ebb80
Reviewed-on: http://review.typo3.org/32742
Reviewed-by: Helmut Hummel <helmut.hummel@typo3.org>
Tested-by: Helmut Hummel <helmut.hummel@typo3.org>

Revision 6d169dd5 - 2014-09-12 17:58 - Jigal van Hemert

[BUGFIX] Followup 2 to mod.SHARED.colPos_list fix

Deal with empty mod.SHARED and fill activeColPosList with colPosList
in case the TSconfig setting is empty.

Resolves: #39967
Releases: 6.2, 6.3
Change-Id: I5e2e4420de8f1d603e13a03758f97803e545d9a3
Reviewed-on: http://review.typo3.org/32743
Reviewed-by: Helmut Hummel <helmut.hummel@typo3.org>
Tested-by: Helmut Hummel <helmut.hummel@typo3.org>

History
#1 - 2012-08-19 23:37 - Jigal van Hemert
True, the setting is not taken in to account. This setting has actually been replaced by the concept of the backend layouts. If you need less columns
you simply create a backend layout for that.
I'd like to drop this setting completely. There are a few solutions to help integrators during the upgrade:
    1. make an upgrade wizard which tries to find these settings and creates backend layouts; this is rather complicated as the setting might apply to a
subtree of the site
    2. make an upgrade wizard which tries to detect the setting and explains how to solve it manually
    3. only document it

#2 - 2012-08-20 01:02 - Michael Stucki
- Status changed from New to Accepted
- Complexity set to easy

I agree that an upgrade wizard could help to replace the old setting entirely. Anyone up for taking over this change?

#3 - 2012-11-27 12:47 - Oliver Hader

Modified for Introduction Package with a new backend layout, see https://review.typo3.org/#/c/16793/

#4 - 2013-04-15 22:12 - Chris topher

With #47071 we have updated the documentation of mod.SHARED.colPos_list so that the documentation says mod.SHARED.colPos_list has been
removed.
The only thing that still needs to be done here is:

Remove mod.SHARED.colPos_list from the code completely.

#5 - 2014-01-09 14:50 - Jo Hasenau

Well - as usual - it is not that easy, since colPos_list and backend layouts are completely different things, with completely different tasks.

While backend layouts provide the structure as such, that will be available for a certain site, colPos_list is meant to restrict the access to these columns
i.e. based on certain conditions.

AFAIK this has been working even together with backend layouts in TYPO3 4.x so removing it silently with 6.0 instead of fixing the bug will now result
in additional problems for people who are upgrading from 4.5 LTS to 6.2 LTS.

IMHO we must revert the removal at least for 6.2, but actually this should be fixed in earlier versions as well.

#6 - 2014-01-09 15:10 - Helmut Hummel
- Target version changed from 6.0.0 to 6.2.0
- TYPO3 Version changed from 6.0 to 6.2
- Is Regression set to No

I agree that we should provide a compatibility layer for that at least for 6.2

#7 - 2014-01-09 15:56 - Jo Hasenau

There is no need for a compatibility layer, since this has been a working feature, that was broken with the patch you mentioned in the description.
Removing it without deprecation is against our CGL, so it currently could not be removed before TYPO3 6.4 or 7.0

Actually it should not be removed, since it is used for another purpose than just a "poor man's backend layout".

#8 - 2014-01-15 16:02 - Patrick Broens

Agree with Joey,

The mentioned patch should be reverted and the issue should be fixed for all versions.

When having a backend layout, you sometimes want to prevent access to a certain column for some users/user groups. At one of my clients (a
university) we are using the setting mod.SHARED.colPos_list together with backend layouts, and it works.

As mentioned by Jo colPos_list and backend layouts are completely different things. The first is for access, the second for structure.

#9 - 2014-02-20 15:16 - Peter Niederlag

+1 for reverting, backend layouts does in no way replace the functionality of mod.SHARED.colPos_list

#10 - 2014-02-26 16:13 - Helmut Hummel
Patrick Broens wrote:

As mentioned by Jo colPos_list and backend layouts are completely different things. The first is for access, the second for structure.

Not really true. The order of colPos_list also mattered and was used to identify the order of columns.

#11 - 2014-02-26 16:19 - Helmut Hummel

Peter Niederlag wrote:

+1 for reverting

reverting what? the layout change?

The question is: How to we deal with the situation. I see following possibilities:

    1. Restore mod.SHARED.colPos_list only when no backend layouts are present
    2. Restore mod.SHARED.colPos_list, but only ignore the order when backend layouts are present (using the info to hide containers with not
matching ids)
    3. Add a new option that adds the possibility to remove containers by colpos from backend layouts
    4. Provide an Upgradewizard (or separate script) adding backend layouts if colPos_list is present (traversing the tree)

#12 - 2014-03-03 17:35 - Peter Niederlag

Prio I
    1. (Re-)Introduce mod.SHARED.colPos_list or introduce a new setting (I don't care to much on the name)
    2. Only purpose of the setting is to influence wether certain columns in dropdown-selections and the page-module are to be shown
    3. The order of the columns should not be within the scope of this setting (I am fine if it is for core)

Nice to have
    1. It might be nice to have both whitelisting as well as blacklisting options (something like colPos_showOnly and colPos_hide)
    2. It might be nice to have influence on the way columns are hidden (something like colPos_hiddenLayout = hidden|readonly)

#13 - 2014-03-23 18:23 - Ernesto Baschny
- Category set to Default
- Target version changed from 6.2.0 to next-patchlevel

This is indeed a feature upgraders from 4.x are expecting which was removed in 6.0. As we don't have time until 6.2.0 now (to be released in two
days), I would opt on an "easy working solution" that we can include as a very special case after 6.2.0 (in 6.2.1 for example).

It should allow admins to do what the old setting did in regards of "hiding" undesired columns. The "order" is not the scope here, this is already handled
by the backend layouts.

I would not put energy in Upgrade Wizards, as this can be documented and those who need it can think about how to use the new possibilities while
upgrading.

Any candidate to work on a solution for this?
#14 - 2014-07-25 01:19 - Gerrit Code Review
- Status changed from Accepted to Under Review

Patch set 1 for branch master of project Packages/TYPO3.CMS has been pushed to the review server.
It is available at http://review.typo3.org/31783

#15 - 2014-07-25 12:00 - Gerrit Code Review

Patch set 2 for branch master of project Packages/TYPO3.CMS has been pushed to the review server.
It is available at http://review.typo3.org/31783

#16 - 2014-07-25 12:05 - Gerrit Code Review

Patch set 3 for branch master of project Packages/TYPO3.CMS has been pushed to the review server.
It is available at http://review.typo3.org/31783

#17 - 2014-07-25 12:21 - Gerrit Code Review

Patch set 4 for branch master of project Packages/TYPO3.CMS has been pushed to the review server.
It is available at http://review.typo3.org/31783

#18 - 2014-07-25 12:22 - Gerrit Code Review

Patch set 5 for branch master of project Packages/TYPO3.CMS has been pushed to the review server.
It is available at http://review.typo3.org/31783

#19 - 2014-07-25 15:42 - Gerrit Code Review

Patch set 6 for branch master of project Packages/TYPO3.CMS has been pushed to the review server.
It is available at http://review.typo3.org/31783

#20 - 2014-09-07 17:03 - Gerrit Code Review

Patch set 1 for branch TYPO3_6-2 of project Packages/TYPO3.CMS has been pushed to the review server.
It is available at http://review.typo3.org/32615

#21 - 2014-09-07 17:30 - Jigal van Hemert
- Status changed from Under Review to Resolved
- % Done changed from 0 to 100

Applied in changeset commit:241f4d0e8bc6568e6d48b084291afe23f5e203cd.
#22 - 2014-09-10 10:31 - Gerrit Code Review
- Status changed from Resolved to Under Review

Patch set 1 for branch master of project Packages/TYPO3.CMS has been pushed to the review server.
It is available at http://review.typo3.org/32697

#23 - 2014-09-10 10:53 - Gerrit Code Review

Patch set 2 for branch master of project Packages/TYPO3.CMS has been pushed to the review server.
It is available at http://review.typo3.org/32697

#24 - 2014-09-10 10:54 - Gerrit Code Review

Patch set 3 for branch master of project Packages/TYPO3.CMS has been pushed to the review server.
It is available at http://review.typo3.org/32697

#25 - 2014-09-10 11:00 - Gerrit Code Review

Patch set 4 for branch master of project Packages/TYPO3.CMS has been pushed to the review server.
It is available at http://review.typo3.org/32697

#26 - 2014-09-10 12:00 - Helmut Hummel
- Status changed from Under Review to Resolved

Applied in changeset commit:20de0fc46b15f783b1884b9d7823617b838c9407.

#27 - 2014-09-10 21:37 - Gerrit Code Review
- Status changed from Resolved to Under Review

Patch set 1 for branch master of project Packages/TYPO3.CMS has been pushed to the review server.
It is available at http://review.typo3.org/32712

#28 - 2014-09-12 17:48 - Gerrit Code Review

Patch set 2 for branch master of project Packages/TYPO3.CMS has been pushed to the review server.
It is available at http://review.typo3.org/32712

#29 - 2014-09-12 17:57 - Gerrit Code Review

Patch set 1 for branch TYPO3_6-2 of project Packages/TYPO3.CMS has been pushed to the review server.
It is available at http://review.typo3.org/32742
#30 - 2014-09-12 17:57 - Gerrit Code Review

Patch set 1 for branch TYPO3_6-2 of project Packages/TYPO3.CMS has been pushed to the review server.
It is available at http://review.typo3.org/32743

#31 - 2014-09-12 18:00 - Jigal van Hemert
- Status changed from Under Review to Resolved

Applied in changeset commit:6a38987010ed732a4f25587fab52a39c336526d5.
